#include "testApp.h"
#include "particle.h"

#include "ofMain.h"

// comparison routine for sort...
bool comparisonFunction(  particle * a, particle * b ) { 
	return a->pos.x < b->pos.x; 
}              
      

//--------------------------------------------------------------
void testApp::setup(){

    ofSetFrameRate(60);
//    for (int i = 0; i < 8000; i++){
//        particle * p = new particle();
//        myParticles.push_back(p);
//        myParticles[i]->pos.set(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()));
//        myParticles[i]->vel.set(0,0);
//    }
	
	ofSetCircleResolution(6);
	ofSetRectMode(OF_RECTMODE_CENTER);
    
    testFont.loadFont("Batang.ttf", 200, true, true, true);
    
    letterSpacing=0;
}

//--------------------------------------------------------------
void testApp::update(){
    
    //APPLY DAMPENNING ON COLISION (WHEN THEY REPEL OR BOUCNE)
	
	//cout << ofGetFrameRate() << endl;
	
	// sort all the particle
	sort( myParticles.begin(), myParticles.end(), comparisonFunction );               // sort them!
	
	
	
	ofBackground(0,0,0); //Grey background, NY style
	
    for (int i = 0; i < myParticles.size(); i++){
        myParticles[i]->resetForce();
    }
	
	
	for (int i = 0; i < myParticles.size(); i++){
		for (int j = i-1; j >= 0; j--){
			if ( fabs(myParticles[j]->pos.x - myParticles[i]->pos.x) >  10) break;
			//just enough force to push the particles off of eachother
			myParticles[i]->addRepulsionForce( *myParticles[j],7,3.0f);
		}
    }
	
	
    for (int i = 0; i < myParticles.size(); i++){
        myParticles[i]->addForce(0, 0.1);
		myParticles[i]->addDampingForce();
        myParticles[i]->bounceOffWalls();
        myParticles[i]->update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	ofSetColor(255,255,255);
	// then draw:
	
	for (int i = 0; i < myParticles.size(); i++){
		 myParticles[i]->draw();
	 }

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){
    string widthTest="";
    widthTest+=(char)key;

    
    if (key!=' '){
        //spacingNum++;
        if (mouseX+letterSpacing+testFont.stringWidth(widthTest)>ofGetWidth())
            letterSpacing=0;
        
            
        //get a new color
        ofColor tempCol;
        tempCol.set(ofRandom(50,255),ofRandom(50,255),ofRandom(50,255));
        
        testChar = testFont.getCharacterAsPoints(key);
        letter = key;
        
        vector <ofPolyline> baseLine;
        //add that letters particles
        for(int k = 0; k <(int)testChar.getOutline().size(); k++){
            if( k!= 0)ofNextContour(true) ;
            ofPolyline thisLine; 
            for(int i = 0; i < (int)testChar.getOutline()[k].size(); i++){
                thisLine.addVertex(testChar.getOutline()[k].getVertices()[i].x, testChar.getOutline()[k].getVertices()[i].y);
            }
            //make sure it connects back to the first point
            thisLine.addVertex(testChar.getOutline()[k].getVertices()[0].x, testChar.getOutline()[k].getVertices()[0].y);
            baseLine.push_back(thisLine);
        }
        
        //resize the polyline to be equaly spaced
        vector <ofPolyline> respacedLine;
        for (int i=0; i<baseLine.size(); i++){
            ofPolyline thisLine=baseLine[i].getResampledBySpacing(10);
            respacedLine.push_back(thisLine);
        }
        for (int k=0; k<respacedLine.size(); k++){
            for (int i = 0; i < respacedLine[k].getVertices().size(); i++){
                particle * p = new particle();
                myParticles.push_back(p);
                myParticles[myParticles.size()-1]->pos.set(letterSpacing+ mouseX+respacedLine[k].getVertices()[i].x, mouseY+respacedLine[k].getVertices()[i].y);
                myParticles[myParticles.size()-1]->vel.set(0,0);
                myParticles[myParticles.size()-1]->col=tempCol;
                myParticles[myParticles.size()-1]->letter=(char)key;
            }
        }
    }
    else{
        //give some space when the user hits space bar
        letterSpacing+=80;
    }
    
    letterSpacing+=testFont.stringWidth(widthTest);

   
}
//--------------------------------------------------------------
void testApp::keyReleased  (int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
    letterSpacing=0;

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
}
